#include "limits.h"
/*@
  requires \valid(p) && \valid(q);
  ensures \result >= *p && \result >= *q;
  ensures \result == *p || \result == *q;
  assigns \nothing;
*/
int max ( int* p, int* q );

/*@ 
  requires \valid(x) && \valid(y);
  assigns *x, *y;
  ensures *x == \at(*y,Pre);
  ensures *y == \at(*x,Pre);
*/
void swap(int* x, int* y);

/*@ requires \valid(low) && \valid(high);
  assigns *high, *low;
  ensures *high == \at(*high, Pre) || *high == \at(*low, Pre);
  ensures *low == \at(*high, Pre) || *low == \at(*low, Pre);
  ensures *high >= *low;
*/
void max_swap( int* low, int* high ) {
  if (*high != max(low,high)) swap(low,high);
}

/*
Local Variables:
compile-command: "frama-c-gui -wp -wp-rte max_swap_proved.c"
End:
*/
