#include "limits.h"
/*@
  requires \valid(p) && \valid(q);
  ensures \result >= *p && \result >= *q;
  ensures \result == *p || \result == *q;
  assigns \nothing;
*/
int max ( int* p, int* q );

/*@ 
  requires \valid(p) && \valid(q);
  assigns *x, *y;
  ensures *x == \at(*y,Pre);
  ensures *y == \at(*x,Pre);
*/
void swap(int* x, int* y);

// ensures that *high contains 
// the maximum of the two values. 
int max_swap( int* low, int* high ) {
  if (*high != max(low,high)) swap(low,high);
}

/*
Local Variables:
compile-command: "frama-c-gui -pp-annot max_swap.c"
End:
*/
